/*
 * Yggdrasil: Minecraft authentication server
 * Copyright (C) 2023 0xf8.dev@proton.me
 *
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

use std::str::FromStr;

use anyhow::{bail, Result};
use log::info;

use structs::profile::Profile;
use yggdrasil::*;

use crate::dbtool::Args;

pub struct DelProfile {}

impl DelProfile {
    pub async fn exec(args: Args, db: &Database) -> Result<()> {
        if args.arguments.len() < 1 { bail!("Not enough arguments. del-profile <id>") }

        // Get id
        let id = i64::from_str(args.arguments.get(0).unwrap())?;

        // Delete profile
        let uuid = Profile::del(db, id).await?;

        info!("Deleted profile(uuid = \"{uuid}\")");

        Ok(())
    }
}
