/*
 * Yggdrasil: Minecraft authentication server
 * Copyright (C) 2023 0xf8.dev@proton.me
 *
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

use log::debug;

use yggdrasil::*;

mod authenticate;
mod invalidate;
mod refresh;
mod signout;
mod validate;

pub fn nest(db: Database) -> tide::Server<Database> {
    debug!("Loading nest");

    let mut nest = tide::with_state(db);
    nest.at("authenticate").post(authenticate::authenticate);
    nest.at("invalidate").post(invalidate::invalidate);
    nest.at("refresh").post(refresh::refresh);
    nest.at("signout").post(signout::signout);
    nest.at("validate").post(validate::validate);

    nest
}
