/*
 * Yggdrasil: Minecraft authentication server
 * Copyright (C) 2023 0xf8.dev@proton.me
 *
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

use log::debug;

use yggdrasil::*;

mod has_joined;
mod join;
mod profile;

pub fn nest(db: Database) -> tide::Server<Database> {
    debug!("Loading nest");

    let mut nest = tide::with_state(db.to_owned());

    nest.at("hasJoined").get(has_joined::has_joined);
    nest.at("join").post(join::join);
    nest.at("profile").nest(super::profile::nest(db.to_owned()));

    nest
}
