/*
 * Yggdrasil: Minecraft authentication server
 * Copyright (C) 2023 0xf8.dev@proton.me
 *
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

use regex::Regex;

pub struct Validate {}

impl Validate {
    pub fn email(e: &str) -> bool {
        Regex::new(r"[a-z0-9_\-.]*@[a-z0-9.]*").unwrap().is_match(e)
    }

    pub fn lang(l: &str) -> bool {
        Regex::new(r"[a-z]{2}-[a-z]{2}").unwrap().is_match(l)
    }

    pub fn country(c: &str) -> bool {
        Regex::new(r"[A-Z]{2}").unwrap().is_match(c)
    }
}

